/*
 *                            *
 *                           * *
 *                          *   *
 *                     ***************
 *                      * *       * *
 *                       *  MUMPS  *
 *                      * *       * *
 *                     ***************
 *                          *   *
 *                           * *
 *                            *
 *
 *   mappings.h
 *    Support of global/routine mappings
 *
 *  
 *   Author: John P. Willis <jpw@coherent-logic.com>
 *    Copyright (C) 1998 MUG Deutschland
 *    Copyright (C) 2020 Coherent Logic Development LLC
 *
 *   Last modified: 12 July 2020
 * 
 **/

#ifndef _MAPPINGS_H
#define _MAPPINGS_H

#define MAPPINGS_MAX 1024

#define MAPT_DEL 0 // this mapping has been deleted
#define MAPT_RTN 1 // this mapping is for a routine
#define MAPT_GBL 2 // this mapping is for a global

typedef struct mapping_ent_t {
	
	/* MAPT_RTN or MAPT_GLOBAL */
	short mapping_type;

	/* The identifier to be mapped */
	char identifier[1024];

	/* The target namespace */
	char namespace[256];

} mapping_ent_t;

void init_mappings();
short map_get(short m_type, char *m_ident, char *buf);
short map_add(short m_type, char *m_ident, char *namespace);
short map_delete(short m_type, char *m_ident);

#endif